#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Funciones estadísticas básicas
"""



# Creamos un conjunto de datos
from numpy import random 

random.seed(1)

datos = random.randint(0,100,300).tolist() + random.randint(20,40,50).tolist()

from matplotlib import pyplot as plt


#%% Promedio o media 

from numpy import mean

print("Valor medio:")
print( mean(datos) )


#%% Mediana 

from numpy import median

print("Valor mediana:")
print( median(datos) )

print("")

datos_ordenados = sorted(datos)

print("Valor mediana (programado):")
print( datos_ordenados[len(datos)//2] )



#%% Moda
from numpy import unique

sin_repetir, conteo = unique(datos, return_counts=True)


print("Valor moda:")
print( sin_repetir[ conteo.argmax() ] )



#%% Grafico 1

plt.hist(datos,100)


#%% Grafico 2

from numpy import linspace

conteo, limites , _= plt.hist(datos,linspace(0,100,21))



#%% Cuantiles y deciles

from numpy import quantile, arange


quantile(datos,[0,0.25,0.5,0.75,1])


quantile(datos,arange(10)/10)




#%% Ejemplo de función

def es_entero(valor):
    "Devuelve True si es entero"
    if round(valor) == valor:
        return True
    else:
        return False 


es_entero(8)
es_entero(4.1)



def listar_divisores(valor):
    "Devuelve una lista de los factore primos"
    
    lista = []
    
    # Recorro los divisores
    for divisor in range(2,int(valor/2)):
        # Si al dividir da entero, lo agrego a la lista
        if es_entero(valor/divisor):
            lista.append( divisor )
        
    # Si no tiene divisores, es primo!
    if len(lista)==0:
        print(f"El número {valor} es primo!")
    
    return lista


listar_divisores(56)
            

listar_divisores(37)




#%% Suma, raiz y desviación estandar

from numpy import * 

print("Comparación de valor medio calculado vs mean")

valor_medio = sum(datos)/len(datos)

print(f"El valor medio calcualado es: {valor_medio}")
print(f"El valor medio con mean   es: {mean(datos)}")

print('\n\n')
print("Desviación estandar")


# datos = array(datos)
desviacion_estandar = sqrt(  sum( (datos-mean(datos))**2)/len(datos)  )

print(f"Desviación estándar calculada: {desviacion_estandar}")
print(f"Desviación estándar con std(): {std(datos)}")


# print(f"Desviación estándar ESTIMADA: {std(datos,ddof=1)}")

